package figure;

public abstract class RegPoly
    implements Figure
{
  private Point2D m_center;
  private int m_nSeg;
  private double m_orient;

  public RegPoly(Point2D center, int n)
  {
    m_center = center;
    m_nSeg = n;
    m_orient = 0;
  }

  public String toString()
  {
    String s = "POLY:\n";
    double ang = 2 * Math.PI / m_nSeg;
    double actualAng = - (Math.PI + ang) / 2 - m_orient;
    for (int i = 0; i < m_nSeg; i++)
    {
      Point2D delta = new Point2D(Math.cos(actualAng),
                                  - Math.sin(actualAng));
      s += "  " + Point2D.add(m_center, delta) + "\n";
      actualAng += ang;
    }
    return s;
  }

  public void traslate(Point2D delta)
  {
    m_center = Point2D.add(m_center, delta);
  }

  public void rotate(double degree)
  {
    m_orient += degree;
  }

  abstract protected double getApotema();

  public double getArea()
  {
    double l = 2 * Math.cos(Math.PI * (m_nSeg - 2) / 2 / m_nSeg);
    return l * getApotema() * m_nSeg / 2;
  }

}
